__gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > Struct Template Reference
Extensions » SGI

`#include <rb_tree>`

## Public Types

template<typename _Iter>
using | __same_value_type
typedef std::_Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > | _Base
template<typename _Compare2>
using | _Compatible_tree
typedef _Base::allocator_type | allocator_type
typedef _Rb_tree_const_iterator< value_type > | const_iterator
typedef const value_type * | const_pointer
typedef const value_type & | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
using | insert_return_type
typedef _Rb_tree_iterator< value_type > | iterator
typedef _Key | key_type
using | node_type
typedef value_type * | pointer
typedef value_type & | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef size_t | size_type
typedef _Val | value_type

## Public Member Functions

| rb_tree (const _Compare &__comp=_Compare(), const allocator_type &__a=allocator_type())
| __attribute ((__abi_tag__("cxx11"))) iterator erase(const_iterator __first
| __attribute ((__abi_tag__("cxx11"))) iterator erase(const_iterator __position)
| __attribute ((__abi_tag__("cxx11"))) iterator erase(iterator __position)
bool | __rb_verify () const
template<typename _Iterator>
void | _M_assign_equal (_Iterator, _Iterator)
template<typename _Iterator>
void | _M_assign_unique (_Iterator, _Iterator)
return __last | _M_const_cast ()
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
size_type | _M_count_tr (const _Kt &__k) const
template<typename... _Args>
iterator | _M_emplace_equal (_Args &&... __args)
template<typename... _Args>
auto | _M_emplace_equal (_Args &&... __args) -> iterator
template<typename... _Args>
iterator | _M_emplace_hint_equal (const_iterator __pos, _Args &&... __args)
template<typename... _Args>
auto | _M_emplace_hint_equal (const_iterator __pos, _Args &&... __args) -> iterator
template<typename... _Args>
iterator | _M_emplace_hint_unique (const_iterator __pos, _Args &&... __args)
template<typename... _Args>
auto | _M_emplace_hint_unique (const_iterator __pos, _Args &&... __args) -> iterator
template<typename... _Args>
pair< iterator, bool > | _M_emplace_unique (_Args &&... __args)
template<typename... _Args>
auto | _M_emplace_unique (_Args &&... __args) -> pair< iterator, bool >
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
pair< iterator, iterator > | _M_equal_range_tr (const _Kt &__k)
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
pair< const_iterator, const_iterator > | _M_equal_range_tr (const _Kt &__k) const
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
iterator | _M_find_tr (const _Kt &__k)
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
const_iterator | _M_find_tr (const _Kt &__k) const
pair< _Base_ptr, _Base_ptr > | _M_get_insert_equal_pos (const key_type &__k)
pair< _Base_ptr, _Base_ptr > | _M_get_insert_hint_equal_pos (const_iterator __pos, const key_type &__k)
pair< _Base_ptr, _Base_ptr > | _M_get_insert_hint_unique_pos (const_iterator __pos, const key_type &__k)
pair< _Base_ptr, _Base_ptr > | _M_get_insert_unique_pos (const key_type &__k)
const _Node_allocator & | _M_get_Node_allocator () const noexcept
_Node_allocator & | _M_get_Node_allocator () noexcept
template<typename _Arg>
iterator | _M_insert_equal (_Arg &&__x)
template<typename _Arg>
iterator | _M_insert_equal_ (const_iterator __pos, _Arg &&__x)
template<typename _Arg, typename _NodeGen>
iterator | _M_insert_equal_ (const_iterator __pos, _Arg &&__x, _NodeGen &)
template<typename _InputIterator>
__enable_if_t<!__same_value_type< _InputIterator >::value > | _M_insert_range_equal (_InputIterator __first, _InputIterator __last)
template<typename _InputIterator>
__enable_if_t< __same_value_type< _InputIterator >::value > | _M_insert_range_equal (_InputIterator __first, _InputIterator __last)
template<typename _InputIterator>
__enable_if_t<!__same_value_type< _InputIterator >::value > | _M_insert_range_unique (_InputIterator __first, _InputIterator __last)
template<typename _InputIterator>
__enable_if_t< __same_value_type< _InputIterator >::value > | _M_insert_range_unique (_InputIterator __first, _InputIterator __last)
template<typename _Arg>
pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator, bool > | _M_insert_unique (_Arg &&__v)
template<typename _Arg>
pair< iterator, bool > | _M_insert_unique (_Arg &&__x)
template<typename _Arg>
iterator | _M_insert_unique_ (const_iterator __pos, _Arg &&__x)
template<typename _Arg, typename _NodeGen>
iterator | _M_insert_unique_ (const_iterator __pos, _Arg &&__x, _NodeGen &)
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
iterator | _M_lower_bound_tr (const _Kt &__k)
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
const_iterator | _M_lower_bound_tr (const _Kt &__k) const
template<typename _Compare2>
void | _M_merge_equal (_Compatible_tree< _Compare2 > &__src) noexcept
template<typename _Compare2>
void | _M_merge_unique (_Compatible_tree< _Compare2 > &__src) noexcept
iterator | _M_reinsert_node_equal (node_type &&__nh)
iterator | _M_reinsert_node_hint_equal (const_iterator __hint, node_type &&__nh)
iterator | _M_reinsert_node_hint_unique (const_iterator __hint, node_type &&__nh)
insert_return_type | _M_reinsert_node_unique (node_type &&__nh)
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
iterator | _M_upper_bound_tr (const _Kt &__k)
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>
const_iterator | _M_upper_bound_tr (const _Kt &__k) const
const_iterator | begin () const noexcept
iterator | begin () noexcept
void | clear () noexcept
size_type | count (const key_type &__k) const
bool | empty () const noexcept
const_iterator | end () const noexcept
iterator | end () noexcept
pair< iterator, iterator > | equal_range (const key_type &__k)
pair< const_iterator, const_iterator > | equal_range (const key_type &__k) const
size_type | erase (const key_type &__x)
node_type | extract (const key_type &__k)
node_type | extract (const_iterator __pos)
iterator | find (const key_type &__k)
const_iterator | find (const key_type &__k) const
allocator_type | get_allocator () const noexcept
_Compare | key_comp () const
iterator | lower_bound (const key_type &__k)
const_iterator | lower_bound (const key_type &__k) const
size_type | max_size () const noexcept
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
size_type | size () const noexcept
void | swap (_Rb_tree &__t) noexcept(/*conditional */)
iterator | upper_bound (const key_type &__k)
const_iterator | upper_bound (const key_type &__k) const

## Public Attributes

const_iterator | __last

## Protected Types

typedef _Rb_tree_node_base * | _Base_ptr
typedef const _Rb_tree_node_base * | _Const_Base_ptr
typedef const _Rb_tree_node< _Val > * | _Const_Link_type
typedef _Rb_tree_node< _Val > * | _Link_type

## Protected Member Functions

_Const_Link_type | _M_begin () const noexcept
_Link_type | _M_begin () noexcept
template<bool _MoveValue, typename _NodeGen>
_Link_type | _M_clone_node (_Link_type __x, _NodeGen &__node_gen)
template<typename... _Args>
void | _M_construct_node (_Link_type __node, _Args &&... __args)
template<typename... _Args>
_Link_type | _M_create_node (_Args &&... __args)
void | _M_destroy_node (_Link_type __p) noexcept
void | _M_drop_node (_Link_type __p) noexcept
_Const_Base_ptr | _M_end () const noexcept
_Base_ptr | _M_end () noexcept
_Link_type | _M_get_node ()
_Const_Base_ptr | _M_leftmost () const noexcept
_Base_ptr & | _M_leftmost () noexcept
_Link_type | _M_mbegin () const noexcept
void | _M_put_node (_Link_type __p) noexcept
_Const_Base_ptr | _M_rightmost () const noexcept
_Base_ptr & | _M_rightmost () noexcept
_Const_Base_ptr | _M_root () const noexcept
_Base_ptr & | _M_root () noexcept

## Static Protected Member Functions

static const _Key & | _S_key (_Const_Base_ptr __x)
static const _Key & | _S_key (_Const_Link_type __x)
static _Link_type | _S_left (_Base_ptr __x) noexcept
static _Const_Link_type | _S_left (_Const_Base_ptr __x) noexcept
static _Base_ptr | _S_maximum (_Base_ptr __x) noexcept
static _Const_Base_ptr | _S_maximum (_Const_Base_ptr __x) noexcept
static _Base_ptr | _S_minimum (_Base_ptr __x) noexcept
static _Const_Base_ptr | _S_minimum (_Const_Base_ptr __x) noexcept
static _Link_type | _S_right (_Base_ptr __x) noexcept
static _Const_Link_type | _S_right (_Const_Base_ptr __x) noexcept

## Protected Attributes

_Rb_tree_impl< _Compare > | _M_impl

## Detailed Description

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>
struct __gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >

This is an SGI extension.

Todo
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Definition at line 79 of file rb_tree.

## Member Typedef Documentation

## __same_value_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Iter>

using std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::__same_value_type

inherited

Definition at line 1095 of file stl_tree.h.

## _Base

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>

typedef std::_Rb_tree<_Key, _Value, _KeyOfValue, _Compare, _Alloc> __gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >::_Base

Definition at line 82 of file rb_tree.

## _Base_ptr

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Rb_tree_node_base* std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr

protected inherited

Definition at line 435 of file stl_tree.h.

## _Compatible_tree

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Compare2>

using std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Compatible_tree

inherited

Definition at line 1552 of file stl_tree.h.

## _Const_Base_ptr

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef const _Rb_tree_node_base* std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Const_Base_ptr

protected inherited

Definition at line 436 of file stl_tree.h.

## _Const_Link_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef const _Rb_tree_node<_Val>* std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Const_Link_type

protected inherited

Definition at line 438 of file stl_tree.h.

## _Link_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Rb_tree_node<_Val>* std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Link_type

protected inherited

Definition at line 437 of file stl_tree.h.

## allocator_type

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>

typedef _Base::allocator_type __gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >::allocator_type

Definition at line 83 of file rb_tree.

## const_iterator

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Rb_tree_const_iterator<value_type> std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_iterator

inherited

Definition at line 818 of file stl_tree.h.

## const_pointer

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef const value_type* std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_pointer

inherited

Definition at line 541 of file stl_tree.h.

## const_reference

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef const value_type& std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_reference

inherited

Definition at line 543 of file stl_tree.h.

## const_reverse_iterator

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef std::reverse_iterator<const_iterator> std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_reverse_iterator

inherited

Definition at line 821 of file stl_tree.h.

## difference_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef ptrdiff_t std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::difference_type

inherited

Definition at line 545 of file stl_tree.h.

## insert_return_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

using std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::insert_return_type

inherited

Definition at line 825 of file stl_tree.h.

## iterator

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Rb_tree_iterator<value_type> std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator

inherited

Definition at line 817 of file stl_tree.h.

## key_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Key std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::key_type

inherited

Definition at line 538 of file stl_tree.h.

## node_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

using std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::node_type

inherited

Definition at line 824 of file stl_tree.h.

## pointer

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef value_type* std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::pointer

inherited

Definition at line 540 of file stl_tree.h.

## reference

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef value_type& std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::reference

inherited

Definition at line 542 of file stl_tree.h.

## reverse_iterator

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef std::reverse_iterator<iterator> std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::reverse_iterator

inherited

Definition at line 820 of file stl_tree.h.

## size_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef size_t std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size_type

inherited

Definition at line 544 of file stl_tree.h.

## value_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Val std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::value_type

inherited

Definition at line 539 of file stl_tree.h.

## Constructor & Destructor Documentation

## rb_tree()

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>

__gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >::rb_tree | ( | const _Compare & | __comp = _Compare(),
|  | const allocator_type & | __a = allocator_type() )

inline

Definition at line 85 of file rb_tree.

## ~rb_tree()

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>

__gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >::~rb_tree | ( |  | ) |

inline

Definition at line 89 of file rb_tree.

## Member Function Documentation

## __attribute() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::__attribute | ( | (__abi_tag__("cxx11")) |  | ) |

inline inherited

Definition at line 1190 of file stl_tree.h.

## __attribute() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::__attribute | ( | (__abi_tag__("cxx11")) |  | ) |

inline inherited

Definition at line 1202 of file stl_tree.h.

## __rb_verify()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

bool std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::__rb_verify | ( |  | ) | const

inherited

Definition at line 2569 of file stl_tree.h.

## _M_assign_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Iterator>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_assign_equal | ( | _Iterator | __first,
|  | _Iterator | __last )

inherited

Definition at line 1765 of file stl_tree.h.

## _M_assign_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Iterator>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_assign_unique | ( | _Iterator | __first,
|  | _Iterator | __last )

inherited

Definition at line 1752 of file stl_tree.h.

## _M_begin() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_begin | ( |  | ) | const

inline protected noexcept inherited

Definition at line 744 of file stl_tree.h.

## _M_begin() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_begin | ( |  | ) |

inline protected noexcept inherited

Definition at line 740 of file stl_tree.h.

## _M_clone_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<bool _MoveValue, typename _NodeGen>

_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_clone_node | ( | _Link_type | __x,
|  | _NodeGen & | __node_gen )

inline protected inherited

Definition at line 639 of file stl_tree.h.

## _M_construct_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename... _Args>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_construct_node | ( | _Link_type | __node,
|  | _Args &&... | __args )

inline protected inherited

Definition at line 592 of file stl_tree.h.

## _M_count_tr()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_count_tr | ( | const _Kt & | __k | ) | const

inline inherited

Definition at line 1314 of file stl_tree.h.

## _M_create_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename... _Args>

_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_create_node | ( | _Args &&... | __args | ) |

inline protected inherited

Definition at line 611 of file stl_tree.h.

## _M_destroy_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_destroy_node | ( | _Link_type | __p | ) |

inline protected noexcept inherited

Definition at line 620 of file stl_tree.h.

## _M_drop_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_drop_node | ( | _Link_type | __p | ) |

inline protected noexcept inherited

Definition at line 631 of file stl_tree.h.

## _M_emplace_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_equal | ( | _Args &&... | __args | ) | ->iterator

inherited

Definition at line 2445 of file stl_tree.h.

## _M_emplace_hint_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_hint_equal | ( | const_iterator | __pos,
|  | _Args &&... | __args )->iterator

inherited

Definition at line 2473 of file stl_tree.h.

## _M_emplace_hint_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_hint_unique | ( | const_iterator | __pos,
|  | _Args &&... | __args )->iterator

inherited

Definition at line 2458 of file stl_tree.h.

## _M_emplace_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_unique | ( | _Args &&... | __args | ) | ->pair< iterator, bool >

inherited

Definition at line 2430 of file stl_tree.h.

## _M_end() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_end | ( |  | ) | const

inline protected noexcept inherited

Definition at line 755 of file stl_tree.h.

## _M_end() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_end | ( |  | ) |

inline protected noexcept inherited

Definition at line 751 of file stl_tree.h.

## _M_equal_range_tr() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

pair< iterator, iterator > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_equal_range_tr | ( | const _Kt & | __k | ) |

inline inherited

Definition at line 1377 of file stl_tree.h.

## _M_equal_range_tr() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

pair< const_iterator, const_iterator > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_equal_range_tr | ( | const _Kt & | __k | ) | const

inline inherited

Definition at line 1387 of file stl_tree.h.

## _M_find_tr() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_find_tr | ( | const _Kt & | __k | ) |

inline inherited

Definition at line 1294 of file stl_tree.h.

## _M_find_tr() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_find_tr | ( | const _Kt & | __k | ) | const

inline inherited

Definition at line 1303 of file stl_tree.h.

## _M_get_insert_equal_pos()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_equal_pos | ( | const key_type & | __k | ) |

inherited

Definition at line 2140 of file stl_tree.h.

## _M_get_insert_hint_equal_pos()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_hint_equal_pos | ( | const_iterator | __pos,
|  | const key_type & | __k )

inherited

Definition at line 2296 of file stl_tree.h.

## _M_get_insert_hint_unique_pos()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_hint_unique_pos | ( | const_iterator | __pos,
|  | const key_type & | __k )

inherited

Definition at line 2210 of file stl_tree.h.

## _M_get_insert_unique_pos()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_unique_pos | ( | const key_type & | __k | ) |

inherited

Definition at line 2108 of file stl_tree.h.

## _M_get_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_node | ( |  | ) |

inline protected inherited

Definition at line 562 of file stl_tree.h.

## _M_get_Node_allocator() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const _Node_allocator & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_Node_allocator | ( |  | ) | const

inline noexcept inherited

Definition at line 553 of file stl_tree.h.

## _M_get_Node_allocator() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Node_allocator & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_Node_allocator | ( |  | ) |

inline noexcept inherited

Definition at line 549 of file stl_tree.h.

## _M_insert_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Arg>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_equal | ( | _Arg && | __x | ) |

inherited

Definition at line 2190 of file stl_tree.h.

## _M_insert_equal_() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Arg>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_equal_ | ( | const_iterator | __pos,
|  | _Arg && | __x )

inline inherited

Definition at line 1072 of file stl_tree.h.

## _M_insert_equal_() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Arg, typename _NodeGen>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_equal_ | ( | const_iterator | __pos,
|  | _Arg && | __x,
|  | _NodeGen & | __node_gen )

inherited

Definition at line 2353 of file stl_tree.h.

## _M_insert_range_equal() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _InputIterator>

__enable_if_t<!__same_value_type< _InputIterator >::value > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_range_equal | ( | _InputIterator | __first,
|  | _InputIterator | __last )

inline inherited

Definition at line 1125 of file stl_tree.h.

## _M_insert_range_equal() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _InputIterator>

__enable_if_t< __same_value_type< _InputIterator >::value > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_range_equal | ( | _InputIterator | __first,
|  | _InputIterator | __last )

inline inherited

Definition at line 1116 of file stl_tree.h.

## _M_insert_range_unique() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _InputIterator>

__enable_if_t<!__same_value_type< _InputIterator >::value > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_range_unique | ( | _InputIterator | __first,
|  | _InputIterator | __last )

inline inherited

Definition at line 1108 of file stl_tree.h.

## _M_insert_range_unique() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _InputIterator>

__enable_if_t< __same_value_type< _InputIterator >::value > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_range_unique | ( | _InputIterator | __first,
|  | _InputIterator | __last )

inline inherited

Definition at line 1099 of file stl_tree.h.

## _M_insert_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Arg>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator, bool > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_unique | ( | _Arg && | __v | ) |

inherited

Definition at line 2162 of file stl_tree.h.

## _M_insert_unique_() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Arg>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_unique_ | ( | const_iterator | __pos,
|  | _Arg && | __x )

inline inherited

Definition at line 1060 of file stl_tree.h.

## _M_insert_unique_() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Arg, typename _NodeGen>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_unique_ | ( | const_iterator | __pos,
|  | _Arg && | __x,
|  | _NodeGen & | __node_gen )

inherited

Definition at line 2271 of file stl_tree.h.

## _M_leftmost() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_leftmost | ( |  | ) | const

inline protected noexcept inherited

Definition at line 724 of file stl_tree.h.

## _M_leftmost() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_leftmost | ( |  | ) |

inline protected noexcept inherited

Definition at line 720 of file stl_tree.h.

## _M_lower_bound_tr() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_lower_bound_tr | ( | const _Kt & | __k | ) |

inline inherited

Definition at line 1323 of file stl_tree.h.

## _M_lower_bound_tr() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_lower_bound_tr | ( | const _Kt & | __k | ) | const

inline inherited

Definition at line 1332 of file stl_tree.h.

## _M_mbegin()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_mbegin | ( |  | ) | const

inline protected noexcept inherited

Definition at line 736 of file stl_tree.h.

## _M_merge_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Compare2>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_merge_equal | ( | _Compatible_tree< _Compare2 > & | __src | ) |

inline noexcept inherited

Merge from a compatible container into one with equivalent keys.

Definition at line 1582 of file stl_tree.h.

## _M_merge_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Compare2>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_merge_unique | ( | _Compatible_tree< _Compare2 > & | __src | ) |

inline noexcept inherited

Merge from a compatible container into one with unique keys.

Definition at line 1560 of file stl_tree.h.

## _M_put_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_put_node | ( | _Link_type | __p | ) |

inline protected noexcept inherited

Definition at line 566 of file stl_tree.h.

## _M_reinsert_node_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_reinsert_node_equal | ( | node_type && | __nh | ) |

inline inherited

Re-insert an extracted node.

Definition at line 1470 of file stl_tree.h.

## _M_reinsert_node_hint_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_reinsert_node_hint_equal | ( | const_iterator | __hint,
|  | node_type && | __nh )

inline inherited

Re-insert an extracted node.

Definition at line 1512 of file stl_tree.h.

## _M_reinsert_node_hint_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_reinsert_node_hint_unique | ( | const_iterator | __hint,
|  | node_type && | __nh )

inline inherited

Re-insert an extracted node.

Definition at line 1490 of file stl_tree.h.

## _M_reinsert_node_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

insert_return_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_reinsert_node_unique | ( | node_type && | __nh | ) |

inline inherited

Re-insert an extracted node.

Definition at line 1441 of file stl_tree.h.

## _M_rightmost() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_rightmost | ( |  | ) | const

inline protected noexcept inherited

Definition at line 732 of file stl_tree.h.

## _M_rightmost() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_rightmost | ( |  | ) |

inline protected noexcept inherited

Definition at line 728 of file stl_tree.h.

## _M_root() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_root | ( |  | ) | const

inline protected noexcept inherited

Definition at line 716 of file stl_tree.h.

## _M_root() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_root | ( |  | ) |

inline protected noexcept inherited

Definition at line 712 of file stl_tree.h.

## _M_upper_bound_tr() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_upper_bound_tr | ( | const _Kt & | __k | ) |

inline inherited

Definition at line 1350 of file stl_tree.h.

## _M_upper_bound_tr() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Kt, typename _Req = __has_is_transparent_t<_Compare, _Kt>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_upper_bound_tr | ( | const _Kt & | __k | ) | const

inline inherited

Definition at line 1359 of file stl_tree.h.

## _S_key() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const _Key & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_key | ( | _Const_Base_ptr | __x | ) |

inline static protected inherited

Definition at line 797 of file stl_tree.h.

## _S_key() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const _Key & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_key | ( | _Const_Link_type | __x | ) |

inline static protected inherited

Definition at line 759 of file stl_tree.h.

## _S_left() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_left | ( | _Base_ptr | __x | ) |

inline static protected noexcept inherited

Definition at line 781 of file stl_tree.h.

## _S_left() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_left | ( | _Const_Base_ptr | __x | ) |

inline static protected noexcept inherited

Definition at line 785 of file stl_tree.h.

## _S_maximum() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_maximum | ( | _Base_ptr | __x | ) |

inline static protected noexcept inherited

Definition at line 809 of file stl_tree.h.

## _S_maximum() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_maximum | ( | _Const_Base_ptr | __x | ) |

inline static protected noexcept inherited

Definition at line 813 of file stl_tree.h.

## _S_minimum() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_minimum | ( | _Base_ptr | __x | ) |

inline static protected noexcept inherited

Definition at line 801 of file stl_tree.h.

## _S_minimum() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_minimum | ( | _Const_Base_ptr | __x | ) |

inline static protected noexcept inherited

Definition at line 805 of file stl_tree.h.

## _S_right() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_right | ( | _Base_ptr | __x | ) |

inline static protected noexcept inherited

Definition at line 789 of file stl_tree.h.

## _S_right() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Const_Link_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_right | ( | _Const_Base_ptr | __x | ) |

inline static protected noexcept inherited

Definition at line 793 of file stl_tree.h.

## begin() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::begin | ( |  | ) | const

inline noexcept inherited

Definition at line 1001 of file stl_tree.h.

## begin() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::begin | ( |  | ) |

inline noexcept inherited

Definition at line 997 of file stl_tree.h.

## clear()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::clear | ( |  | ) |

inline noexcept inherited

Definition at line 1252 of file stl_tree.h.

## count()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::count | ( | const key_type & | __k | ) | const

inherited

Definition at line 2554 of file stl_tree.h.

## empty()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

bool std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::empty | ( |  | ) | const

inline nodiscard noexcept inherited

Definition at line 1029 of file stl_tree.h.

## end() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::end | ( |  | ) | const

inline noexcept inherited

Definition at line 1009 of file stl_tree.h.

## end() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::end | ( |  | ) |

inline noexcept inherited

Definition at line 1005 of file stl_tree.h.

## equal_range() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::equal_range | ( | const key_type & | __k | ) |

inherited

Definition at line 2013 of file stl_tree.h.

## equal_range() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_iterator, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_iterator > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::equal_range | ( | const key_type & | __k | ) | const

inherited

Definition at line 2045 of file stl_tree.h.

## erase()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::erase | ( | const key_type & | __x | ) |

inherited

Definition at line 2516 of file stl_tree.h.

## extract() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

node_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::extract | ( | const key_type & | __k | ) |

inline inherited

Extract a node.

Definition at line 1542 of file stl_tree.h.

## extract() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

node_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::extract | ( | const_iterator | __pos | ) |

inline inherited

Extract a node.

Definition at line 1532 of file stl_tree.h.

## find() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::find | ( | const key_type & | __k | ) |

inherited

Definition at line 2529 of file stl_tree.h.

## find() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::find | ( | const key_type & | __k | ) | const

inherited

Definition at line 2542 of file stl_tree.h.

## get_allocator()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

allocator_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::get_allocator | ( |  | ) | const

inline noexcept inherited

Definition at line 557 of file stl_tree.h.

## key_comp()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Compare std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::key_comp | ( |  | ) | const

inline inherited

Definition at line 993 of file stl_tree.h.

## lower_bound() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::lower_bound | ( | const key_type & | __k | ) |

inline inherited

Definition at line 1269 of file stl_tree.h.

## lower_bound() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::lower_bound | ( | const key_type & | __k | ) | const

inline inherited

Definition at line 1273 of file stl_tree.h.

## max_size()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::max_size | ( |  | ) | const

inline noexcept inherited

Definition at line 1037 of file stl_tree.h.

## rbegin() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_reverse_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::rbegin | ( |  | ) | const

inline noexcept inherited

Definition at line 1017 of file stl_tree.h.

## rbegin() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

reverse_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::rbegin | ( |  | ) |

inline noexcept inherited

Definition at line 1013 of file stl_tree.h.

## rend() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_reverse_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::rend | ( |  | ) | const

inline noexcept inherited

Definition at line 1025 of file stl_tree.h.

## rend() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

reverse_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::rend | ( |  | ) |

inline noexcept inherited

Definition at line 1021 of file stl_tree.h.

## size()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size | ( |  | ) | const

inline noexcept inherited

Definition at line 1033 of file stl_tree.h.

## swap()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::swap | ( | _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > & | __t | ) |

noexcept inherited

Definition at line 2074 of file stl_tree.h.

## upper_bound() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::upper_bound | ( | const key_type & | __k | ) |

inline inherited

Definition at line 1277 of file stl_tree.h.

## upper_bound() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::upper_bound | ( | const key_type & | __k | ) | const

inline inherited

Definition at line 1281 of file stl_tree.h.

## Member Data Documentation

## __last

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::__last

inherited

Definition at line 1236 of file stl_tree.h.

## _M_impl

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Rb_tree_impl<_Compare> std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_impl

protected inherited

Definition at line 708 of file stl_tree.h.

The documentation for this struct was generated from the following file:

- rb_tree